package COM.sun.japan.jl.servlet;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.net.*;

/*
 * uvZT[ubgEAvbgŁṽAvbg
 * T[ubgɂQ̐l𑗐MČʂ󂯎
 */
public class CalcApplet extends Applet
	implements ActionListener
{
	/*
	 * GUI R|[lg
	 */
	private TextField val1Field;
	private TextField val2Field;
	private Button calcButton;
	private TextArea resultView;

	/*
	 * Avbg̊Jn
	 */
	public void init()
	{
		// ʍ쐬
		createScreen();
	}

	/*
	 * {^̃Cxg
	 */
	public void actionPerformed(ActionEvent evt)
	{
		if (evt.getActionCommand().equals("calc")) {
			// vZ
			calc();
		}
	}

	/*
	 * vZ
	 */
	private void calc()
	{
		try {
			// TextField ̒l̎擾
			int val1 = Integer.parseInt(val1Field.getText());
			int val2 = Integer.parseInt(val2Field.getText());

			// T[ubg URL
			URL url = new URL(getDocumentBase(),"/servlet/calcServlet2");

			// T[ubgւ̃RlNVm
			URLConnection conn = url.openConnection();

			// o̓Xg[̎擾
			conn.setDoOutput(true);
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());

			// T[ubgւ̃f[^M  	
			out.writeInt(val1);
			out.writeInt(val2);
			out.flush();

			// ̓Xg[̎擾
			DataInputStream in = new DataInputStream(conn.getInputStream());

			// ʂ̎擾ƕ\
			int result = in.readInt();
			resultView.append("Result=" + result  + "\n");
		}
		catch (NumberFormatException ex) {
			ex.printStackTrace();
			resultView.append("͂͐l݂̂ł\n");
		}
		catch (MalformedURLException ex) {
			ex.printStackTrace();
			resultView.append("s URL ł\n");
		}
		catch (IOException ex) {
			ex.printStackTrace();
			resultView.append("I/O G[ł\n");
		}
	}

	/*
	 * Avbg GUI ̍쐬.
	 */
	private void createScreen()
	{
		// tHg
		setFont(new Font("SansSerif",Font.PLAIN,14));

		// CAEg
		GridBagLayout gb = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.fill = GridBagConstraints.BOTH;
		setLayout(gb);

		// GUI R|[lg̒t
		int ypos = 0;

		// Value1 TextField
		val1Field = new TextField(20);
		addComponent(new Label("Value 1"),gb,gbc,0,ypos,1,1,0.,0.);
		addComponent(val1Field,gb,gbc,1,ypos++,1,1,1.,0.);

		// Value2 TextField
		val2Field = new TextField(20);
		addComponent(new Label("Value 2"),gb,gbc,0,ypos,1,1,0.,0.);
		addComponent(val2Field,gb,gbc,1,ypos++,1,1,1.,0.);

		// vZ{^
		calcButton = new Button("vZ");
		calcButton.setActionCommand("calc");
		calcButton.addActionListener(this);
		addComponent(calcButton,gb,gbc,0,ypos++,2,1,0.,0.);

		// ʕ\GA
		addComponent(new Label(" (Value1 + Value2)"),gb,gbc,0,ypos++,2,1,0.,0.);
		resultView = new TextArea(5,20);
		addComponent(resultView,gb,gbc,0,ypos++,2,1,1.,1.);
	}

	/*
	 * AvbgʂɃR|[lgtȂ.
	 */
	private void addComponent(Component c,GridBagLayout gb,GridBagConstraints gbc,
		int x,int y,int w, int h, double wx, double wy) {
		gbc.weightx = wx;
		gbc.weighty = wy;
		gbc.gridx = x;
		gbc.gridy = y;
		gbc.gridwidth = w;
		gbc.gridheight = h;
		gb.setConstraints(c,gbc);
		add(c);
	}
}
 
