package COM.sun.japan.jl.servlet;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import sun.servlet.http.Cookie;

/**
 * USER_ID  Cookie ɕۑA Login ԂǗT[ubgB
 * Cookie ̎ 3600 błB
 * {NX̃T[ubg loginChecker Ƃēo^B
 *
 */
public class LoginCheckServlet extends HttpServlet {

    // Cookie ̖O
    private static final String ID_COOKIE_NAME = "USER_ID";

    // HTML FORM Ŏgpl
    private static final String SUBMIT_NAME = "SUBMIT";
    private static final String SUBMIT_LOGIN = "LOGIN";
    private static final String SUBMIT_LOGOUT = "LOGOUT";

    // ϐ
    private String idCookieValue;	 // Cookie ̒l
    private String submitValue;		 // GET f[^̒l
    private Cookie idCookie;		 // Cookie
    private boolean loginStatus = false; // OCԃtO

    /**
     * HTTP POST vɑ΂鏈
     */
    protected void doPost(HttpServletRequest req,
			  HttpServletResponse res)
	throws ServletException, IOException
    {
	// POST f[^̎擾
        idCookieValue = req.getParameter(ID_COOKIE_NAME);
        if (idCookieValue == null)
            idCookieValue = "";
        submitValue = req.getParameter(SUBMIT_NAME);
        if (submitValue == null)
            submitValue = "";

	// Cookie ̍쐬
        if (!idCookieValue.equals("")
		&& submitValue.equals(SUBMIT_LOGIN)) {
            idCookie = new Cookie(ID_COOKIE_NAME, idCookieValue);

	    // Cookie ̐ݒ
            idCookie.setMaxAge(3600);
            idCookie.setPath("/");
            idCookie.setDomain(".Japan.Sun.COM");
            idCookie.setSecure(false);

	    // Cookie wb_֐ݒ
            idCookie.saveCookie(res);
        } else {
	    idCookie = null;
	}

	// {fB쐬
        res.setContentType("text/html");
	PrintWriter out = new PrintWriter(new OutputStreamWriter(
		res.getOutputStream()));
	out.print("<!DOCTYPE HTML PUBLIC ");
	out.println("\"-//W3C//DTD HTML 3.2//EN\">");
        out.println("<HTML>");
        if (idCookie == null) {
            out.print("<HEAD><TITLE>Can Not Login");
            out.println("</TITLE></HEAD>");
            out.print("<BODY><H1>Please Try Again.");
            out.println("</H1></BODY>");
        } else {
            out.println("<HEAD><TITLE>Login</TITLE></HEAD>");
            out.println("<BODY><H1>Login Successful.</H1>");
            out.print("<H1><A HREF=\"/servlet/loginChecker\">");
            out.println("Member's Infomation.</A></H1></BODY>");
        }
        out.println("</HTML>");
	out.flush();
	out.close();
    }

    /**
     * HTTP GET vɑ΂鏈
     */
    protected void doGet(HttpServletRequest req,
			 HttpServletResponse res)
        throws ServletException, IOException
    {
	// QueryString 擾
        submitValue = req.getParameter(SUBMIT_NAME);
        if (submitValue == null)
            submitValue = "";

	// Cookie ̎擾
	idCookie = null;
        Cookie cookies[];
        if ((cookies = Cookie.getCookies(req)) != null) {
            for (int i = 0; i < cookies.length; i++) {
                if (cookies[i].getName().equals(ID_COOKIE_NAME)) {
                    idCookie = cookies[i];
                    loginStatus = true;
		    break;
                }
            }
        }

	//Cookie ̑ݒ
        if (idCookie != null) {
            if (submitValue.equals(SUBMIT_LOGOUT)) {
                idCookie.setMaxAge(0);
                loginStatus = false;
            } else {
                idCookie.setMaxAge(3600);
	    }
            idCookie.setPath("/");
            idCookie.setDomain(".Japan.Sun.COM");
            idCookie.setSecure(false);

	    // Cookie  HTTP wb_ɐݒ
            idCookie.saveCookie(res);
        }

	// HTTP {fB쐬
        res.setContentType("text/html");
        PrintWriter out = new PrintWriter(new OutputStreamWriter(
		res.getOutputStream()));
	out.print("<!DOCTYPE HTML PUBLIC");
	out.println(" \"-//W3C//DTD HTML 3.2//EN\">");
        out.print("<HTML><HEAD><TITLE>Information");
	out.println("</TITLE></HEAD><BODY>");
        if (idCookie == null) {
		// G[Ey[W
		out.println("<H1>Please Login.</H1>");
	} else {
	    if (loginStatus) {
		// o[
		out.println("<H1>Member's Information.</H1>");
		out.print("<FORM METHOD=\"GET\" ");
		out.println(" ACTION=\"/servlet/loginChecker\">");
		out.print("<INPUT TYPE=SUBMIT NAME=\"SUBMIT\"");
		out.println(" VALUE=\"LOGOUT\">");
		out.println("</FORM>");
	    } else {
		// Iy[W
		out.print("<H1>Thanks ");
		out.print(idCookie.getValue());
		out.println(".</H1>");
	    }
	}
        out.println("</BODY></HTML>");
	out.flush();
	out.close();
    }

    /**
     * T[ubg̏Ԃ
     */
    public String getServletInfo() {
        return "Management of a Login session with Cookie.";
    }
}
