package COM.sun.japan.jl.servlet;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.io.*;
import java.net.*;

/*
 * uT[ubgṽAvbg
 * [UEC^tF[XƂȂ
 */
public class MemberSearchApplet extends Applet
	implements ActionListener
{
	/*
	 * GUI R|[lg
	 */
	private TextField idField;
	private TextField nameField;
	private TextField addressField;
	private TextField telField;
	private Button searchButton;

	/*
	 * Avbg̊Jn
	 */
	public void init()
	{
		// ʍ쐬
		createScreen();
	}

	/*
	 * {^̃Cxg
	 */
	public void actionPerformed(ActionEvent evt)
	{
		if (evt.getActionCommand().equals("search")) {
			// TextField ̒l̎擾
			int id = Integer.parseInt(idField.getText());

			// T[ubg̎擾
			MemberInfo memberInfo = getMemberInfo(id);

			// \
			displayMemberInfo(memberInfo);
		}
	}

	/*
	 * T[ubg̎擾
	 */
	private MemberInfo getMemberInfo(int id)
	{
		MemberInfo memberInfo = null;

		try {
			// T[ubg URL
			URL url = new URL(getCodeBase(),"/servlet/memberSearchServlet");

			// T[ubgւ̃RlNVm
			URLConnection conn = url.openConnection();

			// o̓Xg[̎擾
			conn.setDoOutput(true);
			DataOutputStream out = new DataOutputStream(conn.getOutputStream());

			// T[ubgւ̃f[^M
			out.writeInt(id);
			out.flush();

			// ̓Xg[̎擾
			ObjectInputStream in = new ObjectInputStream(conn.getInputStream());

			// ʂ̎擾
			Object obj = in.readObject();

			// ʂ̕
			if (obj instanceof MemberInfo) {
				memberInfo = (MemberInfo)obj;
			}
		}
		catch (Exception ex) {
			// ʐMɔ Exception 
			ex.printStackTrace();
		}

		return memberInfo;
	}

	/*
	 * ̕\.
	 */
	private void displayMemberInfo(MemberInfo memberInfo)
	{
		if (memberInfo != null) {
			idField.setText(String.valueOf(memberInfo.getId()));
			nameField.setText(memberInfo.getName());
			addressField.setText(memberInfo.getAddress());
			telField.setText(memberInfo.getTel());
		}
		else {
			nameField.setText("YȂ");
			addressField.setText("");
			telField.setText("");
		}
	}

	/*
	 * Avbg GUI ̍쐬.
	 */
	private void createScreen()
	{
		// tHg
		setFont(new Font("SansSerif",Font.PLAIN,14));

		// CAEg
		GridBagLayout gb = new GridBagLayout();
		GridBagConstraints gbc = new GridBagConstraints();
		gbc.fill = GridBagConstraints.BOTH;
		gbc.insets = new Insets(4,4,4,4);
		setLayout(gb);

		// GUI R|[lg̒t
		int ypos = 0;

		// id TextField
		idField = new TextField(20);
		addComponent(new Label("ID"),gb,gbc,0,ypos,1,1,0.,0.);
		addComponent(idField,gb,gbc,1,ypos++,1,1,1.,0.);

		// {^
		searchButton = new Button("");
		searchButton.setActionCommand("search");
		searchButton.addActionListener(this);
		addComponent(searchButton,gb,gbc,0,ypos++,2,1,0.,0.);

		// name TextField
		nameField = new TextField(20);
		addComponent(new Label(""),gb,gbc,0,ypos,1,1,0.,0.);
		addComponent(nameField,gb,gbc,1,ypos++,1,1,1.,0.);

		// address TextField
		addressField = new TextField(20);
		addComponent(new Label("Z"),gb,gbc,0,ypos,1,1,0.,0.);
		addComponent(addressField,gb,gbc,1,ypos++,1,1,1.,0.);

		// tel TextField
		telField = new TextField(20);
		addComponent(new Label("dbԍ"),gb,gbc,0,ypos,1,1,0.,0.);
		addComponent(telField,gb,gbc,1,ypos++,1,1,1.,0.);

		// dummy panel
		addComponent(new Panel(),gb,gbc,0,ypos++,2,1,1.,1.);
	}

	/*
	 * AvbgʂɃR|[lgtȂ.
	 */
	private void addComponent(Component c,GridBagLayout gb,GridBagConstraints gbc,
		int x,int y,int w, int h, double wx, double wy) {
		gbc.weightx = wx;
		gbc.weighty = wy;
		gbc.gridx = x;
		gbc.gridy = y;
		gbc.gridwidth = w;
		gbc.gridheight = h;
		gb.setConstraints(c,gbc);
		add(c);
	}
}
 
